Debian Bug report logs - #681783
Are Recommends really important (especially for metapackages)?

Package: tech-ctte; Maintainer for tech-ctte is Technical Committee <debian-ctte@lists.debian.org>;

Reported by: Andrei POPESCU <andreimpopescu@gmail.com>

Date: Mon, 16 Jul 2012 14:06:02 UTC

Severity: normal

Done: Don Armstrong <don@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Mon, 16 Jul 2012 14:06:04 GMT) Full text and rfc822 format available.

Message #3 received at submit@bugs.debian.org (full text, mbox):

From: Andrei POPESCU <andreimpopescu@gmail.com>
To: submit@bugs.debian.org
Subject: Are Recommends really important (especially for metapackages)?
Date: Mon, 16 Jul 2012 17:03:54 +0300
[Message part 1 (text/plain, inline)]
Package: tech-ctte

Dear Technical Committee,

Following the big sub-thread "Recommends for metapackages" on 
debian-devel[1] I would like to submit following questions to you as per 
Debian Constitution 6.1, item 5 ("Offer advice"). Examples below are not 
meant to request specific decision(s) from your side or even to point 
fingers at any one package Maintainer (DD or not), but to better explain 
what I think is a more general problem that you could address.

= Timing =

I am aware of the freeze for Debian 7.0 (a.k.a. wheezy) and do 
understand that a possibly favorable outcome is too late to have any 
significant impact on its release (except for possibly delaying it with 
lengthy discussions). However, since it is my hope that such a 
potentially favorable outcome inspires at least some changes for the 
next release, it should not occur much later than shortly after the 
release (e.g. when or right before the Release Team is asking for 
release goals).

= Context / Rationale =

I have been watching Debian development since before APT defaults have 
changed to install Recommends by default. As an aptitude user one of the 
first settings to do at the time for any new installation was to disable 
Recommends, in order to get decent installation sizes.

As soon as the default for APT was changed I did so myself on my 
unstable machine and started filing bugs to suggest adjusting 
dependencies according to the new Debian-wide default. In most cases 
Maintainers have been very responsive and IMO, due to their efforts, 
today it is possible to have a decently sized installation even with 
Recommends enabled.

However, in past years I have witnessed a few cases where maintainers 
insisted on using a Depends relationship, even though many others 
(including Debian Developers) had strong arguments to the opposite[2]. 
This and the "Recommends for metapackages" sub-thread seems to indicate 
that opinions are still quite divergent regarding Recommends.

Given the above and also the recent problems in fitting the two major 
Desktop Environments on only one CD each it would probably help if the 
Technical Committee would take some official position on the following:

1. Is running a system with Recommends turned off a supported 
configuration?

It seems quite a few Debian Developers consider this rather a supported, 
normal configuration, and not a customized, special purpose one. 
Apparently, as a consequence, there is a tendency of having stronger 
than necessary package relationships.

IMO this hurts the very people who would benefit the most from disabling 
Recommends: the ones who actually trim down an installation to the 
minimum, since overriding a Depends is so much more difficult (assuming 
one does even find out about the exaggerated ones).

Based on this rationale, packages should not use Depends unless the 
given package as provided by Debian is unusable (e.g. it would crash) 
without the depended package. An obvious example would be an application 
and it's libraries.

Another, maybe not so obvious consequence is that Maintainers tend to 
use Recommends where Suggests would be more appropriate, leading to 
bloat also in default installations. IMO packages should not use 
Recommends unless it really makes sense to have both packages installed 
in most cases.

Expanding on the previous example, a library should probably not 
Recommend an application, but rather use Suggests. In most cases users 
will not be installing libraries directly anyway and if the library 
gains new reverse dependencies suddenly unrelated packages are installed 
on users' systems[3][4].

Circular Recommends (or Depends/Recommends) relationships should also be 
avoided if technically feasible, as this renders the autoremoval feature 
of package managers almost useless.

If you agree that by disabling Recommends the system administrator 
assumes responsibility for the lack of possibly important
functionality that may even lead to breakage (e.g. rsyslog only 
Recommends: logrotate), this may need a coordinated effort to 
write/adjust some documentation (manpages of package managers, Debian 
Reference, Developer's Reference, Release Notes and possibly others). I 
am willing to help in this regard as much as time allows during the 
following release cycle.

2. Are Depends appropriate for metapackages?

In the above mentioned thread it has been argued that the purpose of 
metapackages is to _guarantee_ a certain set of packages is installed, 
while others argue that Recommends is more than sufficient, given that 
they are installed by default, and it also makes removing individual 
components much easier.

Potential problems on upgrades have been mentioned when using only 
Recommends, but as far as I recall the only concrete example was package 
managers not installing _new_ Recommends by default, which at least for 
apt is not true (according to one of its Maintainers) and should be 
fixable for any others in time for the wheezy+1 release.

IMO metapackages should be using Depends only in very special cases 
(e.g. a Destop Environment doesn't make much sense without the 
corresponding session manager)[5]. If other packages in the collection 
strictly require a specific package they would already depend on it 
anyway and system administrators should be given an easy possibility to 
remove individual components from a collection.

I think this is related to 1., and it would probably make sense to take 
a formal position on this matter too.


References:
[1] http://lists.debian.org/20120710135212.GA5107@r500-debian
[2] #515214 - X can run perfectly well (or even better) without HAL. 
Please make this a Recommends: at most
[3] e.g nmap now uses the system liblinear, which at the time of this 
writing pulls in gnuplot, groff and psutils (via liblinear-tools and 
libsvm-tools, most of them through Recommends). #679992 was filed just a 
few days later after I wrote an e-mail to the Maintainer.
[4] maybe a lintian check like lib-recommends-non-lib-package would make 
sense?
[5] assuming a reliable method to detect metapackages maybe a lintian 
check like metapackage-depends-on-non-metapackage would make sense?

Thank you for reading,
Andrei
-- 
Offtopic discussions among Debian users and developers:
http://lists.alioth.debian.org/mailman/listinfo/d-community-offtopic
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Mon, 16 Jul 2012 15:15:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ijackson@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Mon, 16 Jul 2012 15:15:05 GMT) Full text and rfc822 format available.

Message #8 received at 681783@bugs.debian.org (full text, mbox):

From: Ian Jackson <ijackson@chiark.greenend.org.uk>
To: Andrei POPESCU <andreimpopescu@gmail.com>, 681783@bugs.debian.org
Subject: Re: Bug#681783: Are Recommends really important (especially for metapackages)?
Date: Mon, 16 Jul 2012 15:50:06 +0100
Andrei POPESCU writes ("Bug#681783: Are Recommends really important (especially for metapackages)?"):
> Package: tech-ctte

These questions seems rather abstract to me.  I would rather deal with
them iff they turn out to be relevant to an actual specific package or
package(s).  Are you referring to the discussion surrounding
gnome-core and network-manager ?

If you would like the TC to make a ruling on that specific question
then I'm sure we'd be happy to do so.


> Following the big sub-thread "Recommends for metapackages" on 
> debian-devel[1] I would like to submit following questions to you as per 
> Debian Constitution 6.1, item 5 ("Offer advice"). Examples below are not 
> meant to request specific decision(s) from your side or even to point 
> fingers at any one package Maintainer (DD or not), but to better explain 
> what I think is a more general problem that you could address.

I don't think it would be a good idea for the TC to formally offer
such abstract advice, at least in this case.  The result would seem to
be likely to be arguments over the interpretation of our advice.


But I'm happy to give my personal opinion:

> 1. Is running a system with Recommends turned off a supported 
> configuration?

I would say that "yes it is supported" but that violating a Recommends
may result in unexpected or less favourable behaviour.

Ie, I think a maintainer is at liberty to close bug reports resulting
from violated Recommends with "don't do that then", providing that the
failure mode is reasonable.

> 2. Are Depends appropriate for metapackages?

Yes.


Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Mon, 16 Jul 2012 16:33:09 GMT) Full text and rfc822 format available.

Message #11 received at 681783@bugs.debian.org (full text, mbox):

From: Andrei POPESCU <andreimpopescu@gmail.com>
To: Ian Jackson <ijackson@chiark.greenend.org.uk>
Cc: 681783@bugs.debian.org
Subject: Re: Bug#681783: Are Recommends really important (especially for metapackages)?
Date: Mon, 16 Jul 2012 19:28:49 +0300
[Message part 1 (text/plain, inline)]
On Lu, 16 iul 12, 15:50:06, Ian Jackson wrote:
> Andrei POPESCU writes ("Bug#681783: Are Recommends really important (especially for metapackages)?"):
> > Package: tech-ctte
> 
> These questions seems rather abstract to me.  I would rather deal with
> them iff they turn out to be relevant to an actual specific package or
> package(s).  Are you referring to the discussion surrounding
> gnome-core and network-manager ?
> 
> If you would like the TC to make a ruling on that specific question
> then I'm sure we'd be happy to do so.
 
I am on purpose trying to avoid any specific issue, as I believe at this 
time there are too many in the archive and it would be unproductive for 
all parties involved.
 
> > Following the big sub-thread "Recommends for metapackages" on 
> > debian-devel[1] I would like to submit following questions to you as per 
> > Debian Constitution 6.1, item 5 ("Offer advice"). Examples below are not 
> > meant to request specific decision(s) from your side or even to point 
> > fingers at any one package Maintainer (DD or not), but to better explain 
> > what I think is a more general problem that you could address.
> 
> I don't think it would be a good idea for the TC to formally offer
> such abstract advice, at least in this case.  The result would seem to
> be likely to be arguments over the interpretation of our advice.

If by "this case" you mean gnome-core and network-manager, then by all 
means, delay any ruling until the spirits have settled (this is why I 
mentioned after the release) :)

> But I'm happy to give my personal opinion:
> 
> > 1. Is running a system with Recommends turned off a supported 
> > configuration?
> 
> I would say that "yes it is supported" but that violating a Recommends
> may result in unexpected or less favourable behaviour.
> 
> Ie, I think a maintainer is at liberty to close bug reports resulting
> from violated Recommends with "don't do that then", providing that the
> failure mode is reasonable.

I completely agree. However, maintainers may not want to expose 
themselves to a flood of bugs triggered by some missing un-essential 
functionality[1]. It might help them more if for example all Debian 
documentation was amended first to discourage disabling Recommends. 
Before starting any work on this I'd rather have a "go" from you.
 
[1] I have argued this myself on debian-user on the occasion of Xorg -> 
hal controversy.

Kind regards,
Andrei
-- 
Offtopic discussions among Debian users and developers:
http://lists.alioth.debian.org/mailman/listinfo/d-community-offtopic
[signature.asc (application/pgp-signature, inline)]

Merged 681783 681834 Request was from Don Armstrong <don@debian.org> to control@bugs.debian.org. (Tue, 17 Jul 2012 02:21:04 GMT) Full text and rfc822 format available.

Added indication that bug 681783 blocks 645656 Request was from Ian Jackson <ijackson@chiark.greenend.org.uk> to control@bugs.debian.org. (Tue, 17 Jul 2012 14:15:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Tue, 17 Jul 2012 20:00:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steve Langasek <vorlon@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Tue, 17 Jul 2012 20:00:05 GMT) Full text and rfc822 format available.

Message #20 received at 681783@bugs.debian.org (full text, mbox):

From: Steve Langasek <vorlon@debian.org>
To: Andrei POPESCU <andreimpopescu@gmail.com>, 681783@bugs.debian.org
Subject: Re: Bug#681783: Are Recommends really important (especially for metapackages)?
Date: Tue, 17 Jul 2012 12:35:20 -0700
[Message part 1 (text/plain, inline)]
Hi Andrei,

On Mon, Jul 16, 2012 at 05:03:54PM +0300, Andrei POPESCU wrote:
> Given the above and also the recent problems in fitting the two major 
> Desktop Environments on only one CD each it would probably help if the 
> Technical Committee would take some official position on the following:

> 1. Is running a system with Recommends turned off a supported 
> configuration?

I don't think it's really useful for the Tech Ctte to try to declare whether
or not something is a "supported" configuration.  What is supported is up to
the individual maintainers or to Debian as a whole.

It would better fit within the scope of the committee to ask whether a
particular package relationship should be a Depends or a Recommends, or what
the policy should be for use of Depends vs. Recommends generally.

I do have a definite opinion of my own on this question.  If you are
applying --no-install-recommends to your entire system, you are working
contrary to the intended purpose of Policy, which says:

          The `Recommends' field should list packages that would be found
          together with this one in all but unusual installations.

To avoid the installation of *all* recommends by default is to ignore the
purpose of recommends:  namely, to list packages that *should* be installed
by default, but that the admin *may* remove from the system /if they know
what they're doing/.  The admin who ignores all recommends and leaves them
off the system can't possibly know what they're doing; they're not making an
informed decision that the Recommends are not needed on their installation.

So an admin who has passed --no-install-recommends to apt should not be at
all surprised if some functionality they care about is missing.

> It seems quite a few Debian Developers consider this rather a supported, 
> normal configuration, and not a customized, special purpose one. 
> Apparently, as a consequence, there is a tendency of having stronger 
> than necessary package relationships.

The TC could certainly rule on specific cases of this if asked.  But the
debate about whether --no-install-recommends is sane is a very old one, and
I don't think the TC giving a position statement on this is likely to
influence those who insist on ignoring the meaning of policy.

> Based on this rationale, packages should not use Depends unless the 
> given package as provided by Debian is unusable (e.g. it would crash) 
> without the depended package. An obvious example would be an application 
> and it's libraries.

I think there is flexibility here in how the maintainer draws the line
between Depends and Recommends.  "is unusable" is not exactly the line that
Policy draws.

          The `Depends' field should be used if the depended-on package is
          required for the depending package to provide a significant
          amount of functionality.

There's a certain amount of maintainer judgement inherent in this
definition, which I think is appropriate.

> Circular Recommends (or Depends/Recommends) relationships should also be 
> avoided if technically feasible, as this renders the autoremoval feature 
> of package managers almost useless.

That would be a bug in the package manager's detection of auto-installed
packages, nothing more.

> If you agree that by disabling Recommends the system administrator 
> assumes responsibility for the lack of possibly important
> functionality that may even lead to breakage (e.g. rsyslog only 
> Recommends: logrotate), this may need a coordinated effort to 
> write/adjust some documentation (manpages of package managers, Debian 
> Reference, Developer's Reference, Release Notes and possibly others). I 
> am willing to help in this regard as much as time allows during the 
> following release cycle.

What documentation, specifically, do you see that needs adjusting here? 
Debian Policy is IMHO already quite clear on this, and all other maintainer
documentation is secondary to policy.

> 2. Are Depends appropriate for metapackages?

Given the way you've worded the question here, I think the answer is
definitely "yes".

However, I think that Recommends are *also* appropriate for metapackages.

I don't see anything in the nature of metapackages that exempts them from
the usual process of considering which of the dependencies are hard
dependencies vs. soft dependencies.  Indeed, metapackages in Ubuntu are
maintained in exactly this fashion:

$ apt-cache show ubuntu-desktop | grep Depends | wc -w
82
$ apt-cache show ubuntu-desktop | grep Recommends | wc -w
125
$

For the *specific* case of a gnome metapackage, whose purpose is to install
the gnome system as defined by upstream, I think it's reasonable for the
maintainer to choose to mark as dependencies those packages which are
considered required components of the upstream GNOME system, even when many
Debian users would prefer not to install them.

The problem as I see it is not that the metapackage is constructed wrong,
but that people have differing expectations of what that metapackage
represents.  It's perfectly fine for users to want a convenient way to
install the GNOME desktop while excluding the parts of it that they don't
want; however, there's no reason that a) such a metapackage should be called
'gnome', or b) the GNOME package maintainers should be the ones to maintain
this, if their goal is to deliver the complete GNOME desktop as defined by
upstream.

Now, we might also decide that this metapackage is not the right thing for
Debian to install as its default desktop.  I believe that to date, the
installer team have delegated the decisions about what to include in the
default desktop over to the GNOME team.  If we think that this metapackage
gives the wrong behavior for a default Debian desktop, we might replace it
with a different one - perhaps one that the GNOME team would be willing to
maintain and keep synchronized with the existing package, but under a
different binary package name.

-- 
Steve Langasek                   Give me a lever long enough and a Free OS
Debian Developer                   to set it on, and I can move the world.
Ubuntu Developer                                    http://www.debian.org/
slangasek@ubuntu.com                                     vorlon@debian.org
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Thu, 19 Jul 2012 05:27:07 GMT) Full text and rfc822 format available.

Message #23 received at 681783@bugs.debian.org (full text, mbox):

From: Andrei POPESCU <andreimpopescu@gmail.com>
To: Steve Langasek <vorlon@debian.org>
Cc: 681783@bugs.debian.org
Subject: Re: Bug#681783: Are Recommends really important (especially for metapackages)?
Date: Thu, 19 Jul 2012 08:25:03 +0300
[Message part 1 (text/plain, inline)]
On Ma, 17 iul 12, 12:35:20, Steve Langasek wrote:
> 
> > 1. Is running a system with Recommends turned off a supported 
> > configuration?
> 
> I don't think it's really useful for the Tech Ctte to try to declare whether
> or not something is a "supported" configuration.  What is supported is up to
> the individual maintainers or to Debian as a whole.
> 
> It would better fit within the scope of the committee to ask whether a
> particular package relationship should be a Depends or a Recommends, or what
> the policy should be for use of Depends vs. Recommends generally.

Yes, a general policy would probably address my question.

> I do have a definite opinion of my own on this question.  If you are
> applying --no-install-recommends to your entire system, you are working
> contrary to the intended purpose of Policy, which says:
> 
>           The `Recommends' field should list packages that would be found
>           together with this one in all but unusual installations.
> 
> To avoid the installation of *all* recommends by default is to ignore the
> purpose of recommends:  namely, to list packages that *should* be installed
> by default, but that the admin *may* remove from the system /if they know
> what they're doing/.  The admin who ignores all recommends and leaves them
> off the system can't possibly know what they're doing; they're not making an
> informed decision that the Recommends are not needed on their installation.
> 
> So an admin who has passed --no-install-recommends to apt should not be at
> all surprised if some functionality they care about is missing.

I fully agree, and this (plus Ian's answer) is pretty much what my own 
impression is and what I had expected. But this is not reflected in user 
or developer oriented documentation (except Policy, of course). I'll be 
filing (wishlist) bugs for debian-reference, apt (apt-get(8)), aptitude 
(aptitude(8)) and so on.
 
> > It seems quite a few Debian Developers consider this rather a supported, 
> > normal configuration, and not a customized, special purpose one. 
> > Apparently, as a consequence, there is a tendency of having stronger 
> > than necessary package relationships.
> 
> The TC could certainly rule on specific cases of this if asked.  But the
> debate about whether --no-install-recommends is sane is a very old one, and
> I don't think the TC giving a position statement on this is likely to
> influence those who insist on ignoring the meaning of policy.

My intention was for you to give Maintainers a sort of backup for cases 
where others may disagree with a weaker dependency.

> > Based on this rationale, packages should not use Depends unless the 
> > given package as provided by Debian is unusable (e.g. it would crash) 
> > without the depended package. An obvious example would be an application 
> > and it's libraries.
> 
> I think there is flexibility here in how the maintainer draws the line
> between Depends and Recommends.  "is unusable" is not exactly the line that
> Policy draws.
> 
>           The `Depends' field should be used if the depended-on package is
>           required for the depending package to provide a significant
>           amount of functionality.
> 
> There's a certain amount of maintainer judgement inherent in this
> definition, which I think is appropriate.

Sure, leaving some space for individual Maintainers makes sense, but 
"significant amount of functionality" is quite wide. Wouldn't something 
like "to function properly" be better? (I'm sure this has been debated a 
lot, so I'll be researching this on first occasion. Would appreciate 
some bug numbers though if you have them handy)

> > Circular Recommends (or Depends/Recommends) relationships should also be 
> > avoided if technically feasible, as this renders the autoremoval feature 
> > of package managers almost useless.
> 
> That would be a bug in the package manager's detection of auto-installed
> packages, nothing more.

Ok, I've just found #655483, I'll be following that.

> > If you agree that by disabling Recommends the system administrator 
> > assumes responsibility for the lack of possibly important
> > functionality that may even lead to breakage (e.g. rsyslog only 
> > Recommends: logrotate), this may need a coordinated effort to 
> > write/adjust some documentation (manpages of package managers, Debian 
> > Reference, Developer's Reference, Release Notes and possibly others). I 
> > am willing to help in this regard as much as time allows during the 
> > following release cycle.
> 
> What documentation, specifically, do you see that needs adjusting here? 
> Debian Policy is IMHO already quite clear on this, and all other maintainer
> documentation is secondary to policy.
> 
> > 2. Are Depends appropriate for metapackages?
> 
> Given the way you've worded the question here, I think the answer is
> definitely "yes".
> 
> However, I think that Recommends are *also* appropriate for metapackages.

I think it makes sense to wait for the resolution to #681834 before 
discussing this any further.

Kind regards,
Andrei
-- 
Offtopic discussions among Debian users and developers:
http://lists.alioth.debian.org/mailman/listinfo/d-community-offtopic
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Tue, 07 Aug 2012 16:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ijackson@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Tue, 07 Aug 2012 16:51:03 GMT) Full text and rfc822 format available.

Message #28 received at 681783@bugs.debian.org (full text, mbox):

From: Ian Jackson <ijackson@chiark.greenend.org.uk>
To: 681783@bugs.debian.org
Subject: Re: Recommends, and metapackages
Date: Tue, 7 Aug 2012 17:48:30 +0100
Here is my proposal for a disposal of #681783, re Recommends and
particularly metapackages.

  Whereas:

  1. The Technical Committee's view is that the existing policy
     on Recommends is correct.

  2. Specifically, we feel that there is nothing inherently wrong with
     using Recommends in a metapackage.  Any infelicities in package
     management software's handling of Recommends (in metapackages or
     more generally) should be treated as bugs.

  3. It may be that policy could be clarified in this area, for
     example to make it clear that if a user chooses not to install
     Recommends, some things may not work, and that that would not be
     a bug.

  Therefore:

  4. We do not make a ruling about the content of policy.

  5. We advise the policy maintainers to consider how to clarify
     this, and to make whatever changes they consider appropriate.

I propose this as a resolution.  In the absence of dissent, I will
call for a vote in a week or so.  If it passes, point 5 (about advice
to the policy maintainers) will be implemented by me filing a bug
against policy.

Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Tue, 14 Aug 2012 12:48:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ijackson@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Tue, 14 Aug 2012 12:48:06 GMT) Full text and rfc822 format available.

Message #33 received at 681783@bugs.debian.org (full text, mbox):

From: Ian Jackson <ijackson@chiark.greenend.org.uk>
To: 681783@bugs.debian.org
Subject: Call for votes on Recommends and metapackages
Date: Tue, 14 Aug 2012 13:44:16 +0100
I'm calling for a vote on my proposal for a disposal of #681783, re
Recommends and particularly metapackages.

The options are:
  A   Recommends policy is correct, clarification would be useful
  F   Further discussion.

Here is the full text of the resolution option A:

  Whereas:

  1. The Technical Committee's view is that the existing policy
     on Recommends is correct.

  2. Specifically, we feel that there is nothing inherently wrong with
     using Recommends in a metapackage.  Any infelicities in package
     management software's handling of Recommends (in metapackages or
     more generally) should be treated as bugs.

  3. It may be that policy could be clarified in this area, for
     example to make it clear that if a user chooses not to install
     Recommends, some things may not work, and that that would not be
     a bug.

  Therefore:

  4. We do not make a ruling about the content of policy.

  5. We advise the policy maintainers to consider how to clarify
     this, and to make whatever changes they consider appropriate.

If this passes, point 5 (about advice to the policy maintainers) will
be implemented by me filing a bug against policy.

Thanks,
Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Tue, 14 Aug 2012 12:51:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ijackson@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Tue, 14 Aug 2012 12:51:09 GMT) Full text and rfc822 format available.

Message #38 received at 681783@bugs.debian.org (full text, mbox):

From: Ian Jackson <ijackson@chiark.greenend.org.uk>
To: 681783@bugs.debian.org
Subject: Re: Bug#681783: Call for votes on Recommends and metapackages
Date: Tue, 14 Aug 2012 13:48:40 +0100
Ian Jackson writes ("Bug#681783: Call for votes on Recommends and metapackages"):
> I'm calling for a vote on my proposal for a disposal of #681783, re
> Recommends and particularly metapackages.
> 
> The options are:
>   A   Recommends policy is correct, clarification would be useful
>   F   Further discussion.

I vote
   A F

Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Tue, 14 Aug 2012 18:33:04 GMT) Full text and rfc822 format available.

Message #41 received at 681783@bugs.debian.org (full text, mbox):

From: Andreas Barth <aba@ayous.org>
To: debian-ctte@lists.debian.org
Subject: Re: Bug#681783: Call for votes on Recommends and metapackages
Date: Tue, 14 Aug 2012 20:10:40 +0200
* Ian Jackson (ijackson@chiark.greenend.org.uk) [120814 14:48]:
> I'm calling for a vote on my proposal for a disposal of #681783, re
> Recommends and particularly metapackages.
> 
> The options are:
>   A   Recommends policy is correct, clarification would be useful
>   F   Further discussion.

I vote AF.


Andi


-- 
To UNSUBSCRIBE, email to debian-ctte-REQUEST@lists.debian.org
with a subject of "unsubscribe". Trouble? Contact listmaster@lists.debian.org
Archive: http://lists.debian.org/20120814181040.GO2385@mails.so.argh.org





Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Fri, 17 Aug 2012 23:42:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Don Armstrong <don@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Fri, 17 Aug 2012 23:42:03 GMT) Full text and rfc822 format available.

Message #46 received at 681783@bugs.debian.org (full text, mbox):

From: Don Armstrong <don@debian.org>
To: 681783@bugs.debian.org
Subject: Re: Bug#681783: Call for votes on Recommends and metapackages
Date: Fri, 17 Aug 2012 16:37:58 -0700
On Tue, 14 Aug 2012, Ian Jackson wrote:
> I'm calling for a vote on my proposal for a disposal of #681783, re
> Recommends and particularly metapackages.
> 
> The options are:
>   A   Recommends policy is correct, clarification would be useful
>   F   Further discussion.

I vote AF.


Don Armstrong

-- 
Some pirates achieved immortality by great deeds of cruelty or
daring-do. Some achieved immortality by amassing great wealth. But
the captain had long ago decided that he would, on the whole, prefer
to achieve immortality by not dying.
 -- Terry Pratchet _The Color of Magic_

http://www.donarmstrong.com              http://rzlab.ucr.edu



Marked Bug as done Request was from Don Armstrong <don@debian.org> to control@bugs.debian.org. (Sat, 18 Aug 2012 01:39:03 GMT) Full text and rfc822 format available.

Notification sent to Andrei POPESCU <andreimpopescu@gmail.com>:
Bug acknowledged by developer. (Sat, 18 Aug 2012 01:39:04 GMT) Full text and rfc822 format available.

Message #51 received at 681783-done@bugs.debian.org (full text, mbox):

From: Don Armstrong <don@debian.org>
To: 681783-done@bugs.debian.org
Subject: Re: Bug#681783: Call for votes on Recommends and metapackages
Date: Fri, 17 Aug 2012 18:33:49 -0700
clone 681783 -1
reassign -1 debian-policy
reopen -1
retitle -1 debian-policy Consider clarifying the use of recommends
close 681783
thanks

With my vote, the outcome is no longer in doubt:

Ian Jackson:   AF
Russ Allbery:  AF
Andreas Barth: AF
Don Armstrong: AF

and we adopt the following resolution:

  Whereas:

  1. The Technical Committee's view is that the existing policy
     on Recommends is correct.

  2. Specifically, we feel that there is nothing inherently wrong with
     using Recommends in a metapackage.  Any infelicities in package
     management software's handling of Recommends (in metapackages or
     more generally) should be treated as bugs.

  3. It may be that policy could be clarified in this area, for
     example to make it clear that if a user chooses not to install
     Recommends, some things may not work, and that that would not be
     a bug.

  Therefore:

  4. We do not make a ruling about the content of policy.

  5. We advise the policy maintainers to consider how to clarify
     this, and to make whatever changes they consider appropriate.

===========

Additionally, this bug has been cloned and reassigned to debian-policy
in accordance with #5. I will send a mail to d-d-a shortly announcing
this decision.


Don Armstrong

-- 
I'm wrong to criticize the valor of your brave men. It's important to
die for one's country when it means being the subject of a king who
wears a ruffled collar or a pleated one.
 -- Cyrano de Bergerac

http://www.donarmstrong.com              http://rzlab.ucr.edu



Disconnected #681783 from all other report(s). Request was from Don Armstrong <don@debian.org> to control@bugs.debian.org. (Fri, 24 Aug 2012 08:30:03 GMT) Full text and rfc822 format available.

Bug 681783 cloned as bug 685746 Request was from Don Armstrong <don@debian.org> to control@bugs.debian.org. (Fri, 24 Aug 2012 08:30:04 GMT) Full text and rfc822 format available.

Merged 681783 681834 Request was from Don Armstrong <don@debian.org> to control@bugs.debian.org. (Fri, 24 Aug 2012 08:30:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Fri, 24 Aug 2012 13:45:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ijackson@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Fri, 24 Aug 2012 13:45:06 GMT) Full text and rfc822 format available.

Message #62 received at 681783@bugs.debian.org (full text, mbox):

From: Ian Jackson <ijackson@chiark.greenend.org.uk>
To: 681783@bugs.debian.org
Subject: Re: Bug#681783: Call for votes on Recommends and metapackages
Date: Fri, 24 Aug 2012 14:41:12 +0100
Don wrote, on the 17th of August:
> With my vote, the outcome is no longer in doubt:
> 
> Ian Jackson:   AF
> Russ Allbery:  AF
> Andreas Barth: AF
> Don Armstrong: AF
> 
> and we adopt the following resolution:
> 
>   Whereas:
> 
>   1. The Technical Committee's view is that the existing policy
>      on Recommends is correct.
> 
>   2. Specifically, we feel that there is nothing inherently wrong with
>      using Recommends in a metapackage.  Any infelicities in package
>      management software's handling of Recommends (in metapackages or
>      more generally) should be treated as bugs.
> 
>   3. It may be that policy could be clarified in this area, for
>      example to make it clear that if a user chooses not to install
>      Recommends, some things may not work, and that that would not be
>      a bug.
> 
>   Therefore:
> 
>   4. We do not make a ruling about the content of policy.
> 
>   5. We advise the policy maintainers to consider how to clarify
>      this, and to make whatever changes they consider appropriate.
> 
> ===========
> 
> Additionally, this bug has been cloned and reassigned to debian-policy
> in accordance with #5. I will send a mail to d-d-a shortly announcing
> this decision.

However he sent his message to 681783-done (only) so it didn't go to
the TC list, so I'm quoting it all here so we have a message on the
-ctte list.

The bug against policy was created by Don cloning #681783 as #685746.

I will send a message to debian-devel-announce.

Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#681783; Package tech-ctte. (Fri, 24 Aug 2012 13:54:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ijackson@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. (Fri, 24 Aug 2012 13:54:03 GMT) Full text and rfc822 format available.

Message #67 received at 681783@bugs.debian.org (full text, mbox):

From: Ian Jackson <ijackson@chiark.greenend.org.uk>
To: 681834@bugs.debian.org, 681783@bugs.debian.org
Subject: gnome-core metapackage network-manager dependency
Date: Fri, 24 Aug 2012 14:50:56 +0100
unmerge 681834
retitle 681834 Dependency from network-manager to gnome
reopen 681834 =
thanks

We have dealt with the general issue of Recommends in metapackages.

We have been also discussing the merits of the specific hard
dependency from gnome-core to network-manager-gnome (pulling in
network-manager), in #681834.  See the bug log and email thread for
#681834.

However, even though we have been treating these issues separately,
these bugs were merged at the point when Don closed #681783 (the
general issue), so #681834 fell off our todo list.

So: unmerge and reopen #681834 and clarify the title.

Ian.



Disconnected #681834 from all other report(s). Request was from Ian Jackson <ijackson@chiark.greenend.org.uk> to control@bugs.debian.org. (Fri, 24 Aug 2012 13:54:07 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sat, 22 Sep 2012 07:28:22 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 06:02:13 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.